; gdo.asm: szinuszos vco

	list p=12F1840
	list r=dec
	#include <p12F1840.inc>
	
	__CONFIG _CONFIG1, _FOSC_INTOSC & _WDTE_OFF & _PWRTE_ON & _MCLRE_ON & _CP_OFF & _CPD_OFF & _BOREN_OFF & _CLKOUTEN_OFF & _IESO_OFF & _FCMEN_OFF
	__CONFIG _CONFIG2, _WRT_OFF & _PLLEN_ON & _STVREN_OFF & _BORV_HI & _LVP_OFF
	
delta	equ	105	; eltols 105 egysg (200,27 Hz) 
			; fels hatr 1128 egysg (2151,5 Hz)
hyst	equ	6	; hang ki-be kapcsolsi hiszterzis (11,44 Hz)
kikap	equ	8	; kikapcsols 8, eltolva 113 egysg (215,5 Hz)
			; vissza 6+8=14, eltolva 119 egysg (227 Hz)
; DDS rafrekvencia: 125 kHz, nem llthat. Fzisakkumultor: 16 bit.
; Frekvenciafelbonts: 1,907349 Hz, feszltsgszintek szma 63.

	cblock	0x70
	frh	; frekvenciaregiszter
	frl
	phh	; fzisakkumultor
	phl
	bufh	; ADC eredmny tvev, feldolgoz,tovbbad regiszter
	bufl
	adcnt	; ADC mintavteli peridus idzt
	flags	; jelzbitek
	endc
#define flag	flags,2	; van kiszmolt adat
#define finom	flags,1	; indulskor ra3=0
#define	tilt	flags,0	; kimenet tiltsa
#define adgo	adcon0,go_not_done
#define adi	pir1,adif

; nhny Parallax makr:
clc	macro
	bcf	status,c
	endm
stc	macro
	bsf	status,c
	endm
snc	macro
	btfsc	status,c
	endm
sc	macro
	btfss	status,c
	endm
snz	macro
	btfsc	status,z
	endm
sz	macro
	btfss	status,z
	endm
sb	MACRO Port,bit	;skip if bit is set
	btfss Port,bit
	ENDM
snb   MACRO Port,bit	;skip if bit is cleared 
	btfsc Port,bit
	ENDM
csal   MACRO fr,L		;compare and skip if fr > L
	movlw L^0ffh
	addwf fr,W
	btfss 3,0
	ENDM
csbl   MACRO fr,L		;compare and skip if fr < L 
	movlw L
	subwf fr,W
	btfsc 3,0
	ENDM
jnz  MACRO  addr			;jump if zero bit is not set 
	btfss 3,2
	goto addr
	ENDM
jz  MACRO  addr			;jump if zero bit is set 
	btfsc 3,2
	goto addr
	ENDM
	
	org	0
	nop
	goto	start
; megszakts, mr nem kell szmolni a hosszt	
	org	4
	banksel	0	;3
	bcf	pir1,tmr2if
	movf	frl,w	;5
	addwf	phl,f
	movf	frh,w
	addwfc	phh,f
	movf	phh,w
	movwf	fsr0l
	moviw	0[fsr0]
	banksel	ccpr1l	;13
	movwf	ccpr1l
	banksel	adcon0
	decf	adcnt,f
	snz
	bsf	adgo	; 256/250 ms-onknt egy minta
	sb	flag
	retfie
	bcf	flag	;21
	movf	bufl,w
	movwf	frl
	movf	bufh,w
	movwf	frh
	retfie		; 27 (max.29)
		
; incializlni kell, aztn mehet!	
start
	banksel	porta	
	movlw	0	
	movwf	porta
	banksel	trisa	
	movlw	1ah
	movwf	trisa
	banksel	wpua
	movlw	0ah
	movwf	wpua
	banksel	ansela
	movlw	10h
	movwf	ansela
	banksel	adcon0
	movlw	0a3h
	movwf	adcon1
	movlw	0dh	
	movwf	adcon0	
	banksel	option_reg
	movlw	8
	movwf	option_reg
	banksel	osccon
	movlw	70h	; 8 x 4 = 32 MHz
	movwf	osccon
	banksel	0
	clrf	flags
	sb	porta,1
	bsf	finom
	banksel	fvrcon
	movlw	83h
	snb	finom
	movlw	81h
	movwf	fvrcon
	banksel	pr2
	movlw	63
	movwf	pr2
	clrf	tmr2
	banksel	pie1
	bsf	pie1,tmr2ie
	banksel	ccp1con
	clrf	pwm1con
	movlw	8ch
	movwf	ccp1con
	clrf	ccpr1l
	banksel	t2con
	bsf	t2con,tmr2on	
	banksel	porta
	movlw	high kicsi
	movwf	fsr0h
	clrf	pir1
	movlw	4
	movwf	adcnt
	movlw	1
	movwf	frh
	clrf	frl
	clrf	phl
	clrf	phh
	clrf	fsr0l
	bsf	intcon,peie
	bsf	intcon,gie
		
main
	banksel	0
	sb	adi
	goto	main
	bcf	adi
	banksel	adresh
	movf	adresh,w
	movwf	bufh
	movf	adresl,w
	movwf	bufl
	movlw	4
	addwf	bufl,f
	movlw	0
	addwfc	bufh,f
	banksel	lata
	sb	bufh,2
	goto	sk0
	bcf	lata,5
	goto	sk2
sk0	
	movlw	8
	addwf	bufl,f
	movlw	0
	addwfc	bufh,f
	sb	bufh,2
	bsf	lata,5
sk2
	banksel	0
	movf	bufh,f
	jnz	good	;jkora
	csal	bufl,kikap+12
	bsf	tilt	;bufl 50 alatt: tilt be
	csbl	bufl,kikap+12+hyst
	bcf	tilt	;bufl 60 fltt: nem tilt
good
	movlw	delta-12
	addwf	bufl,f
	clrw
	addwfc	bufh,f
	banksel	ccp1con
	movlw	8ch
	xorwf	ccp1con,w
	jz	sk1	;be van kapcsolva: nem kell bekapcsolni
	movlw	8ch
	sb	tilt
	movwf	ccp1con ; nincs tiltva, ki van kapcsolva: bekapcsolni
sk1
	snb	tilt
	clrf	ccp1con ; tilt: ki kell kapcsolni
	bsf	flag
	goto	main

	org	200h
	#include <sinus64.inc>
	end
	