; idoszava.asm: az id szava
	list p=10f320
	list r=dec
	#include <p10f320.inc>
	#include <prlx.inc>
	
	__config	2486h	
	
	cblock 40h
	wtemp
	stemp
	flags
	phc
	div_20	; 20-as oszt, a 10-es utn, 2 msodperc mrshez
	div_10	; 10-es oszt, 10 Hz-et csinl gombhoz, adshoz
	msg:4
	aux1
	aux2
	cnt_2
	wcnt
	bcnt
	mcnt
	endc

#define	out	lata,1
#define sound	lata,2
#define	gomb	porta,3
#define	fut	flags,0
#define	adgo	adcon,go_not_done
#define	ton	t2con,tmr2on
freki	equ	1678

	org	0
	goto	start
	org	4
	movwf	wtemp	; szabvny ments, flagtrls
	swapf	status,w
	clrf	status
	movwf	stemp
	bcf	pir1,tmr2if
	decf	div_10,f	; lassts 10 Hz-re
	sz
	goto	rld
	movlw	10
	movwf	div_10	
; fzis szerinti teendk
	decf	phc,w
	addwf	pcl,f
	goto	ph1
	goto	ph2
	goto	ph3
	goto	ph4
	goto	ph5
ph1			; beolvas, komparl, inkrementl ha mg lehet
	djnz	div_20,rld
; innen a 2 msodpercenknti feladat
	bsf	adgo
	movlw	20
	movwf	div_20
adwt
	jb	adgo,adwt
	cjbl	adres,8,ph5
	incf	cnt_2,f
	cja	adres,cnt_2,rld
	bcf	out
	incf	phc,f
	bcf	ton
	clrf	tmr2
	bsf	ton
	movlw	15
	movwf	wcnt
	movlw	20
	movwf	bcnt
	movlw	s_rdy
	call	load4
	goto	rld
ph2
	sb	gomb
	goto	emex
	call	sendbit
	decfsz	bcnt,f
	goto	rld
	movlw	20
	movwf	bcnt
	movlw	s_rdy
	call	load4
	decfsz	wcnt,f
	goto	rld
	incf	phc,f
	movlw	32
	movwf	bcnt
	movlw	9
	movwf	wcnt
	movlw	s_sos
	call	load4
	goto	rld
ph3
	sb	gomb
	goto	emex
	call	sendbit
	decfsz	bcnt,f
	goto	rld
	movlw	32
	movwf	bcnt
	movlw	s_sos
	call	load4
	decfsz	wcnt,f
	goto	rld
	incf	phc,f
	movlw	32
	movwf	bcnt
	movlw	s_rip
	call	load4
	goto	rld
ph4
	sb	gomb
	goto	emex
	call	sendbit
	decfsz	bcnt,f
	goto	rld
	incf	phc,f
	goto	rld
emex	
	movlw	4
	movwf	phc
	clrf	lata
	goto	rld
ph5
	clrf	phc
	clrf	lata
	bcf	ton
	
rld				; visszallt, kilp	
	swapf	stemp,w
	movwf	status
	swapf	wtemp,f
	swapf	wtemp,w
	retfie
; ez amikor szlnia kell vagy hallgatnia
sendbit
	bcf	status,c
	rlf	msg+3,f
	rlf	msg+2,f
	rlf	msg+1,f
	rlf	msg,f
	snc
	bsf	sound
	sc
	bcf	sound
	return
start	; fprogram
	clrf	porta	;minden kimenet nullrl induljon, J
	movlw	30h
	movwf	osccon	; 1 MHz, J
	movlw	8h
	movwf	option_reg	; lehet felhz
	movlw	9
	movwf	trisa	; 2 bemenet
	movlw	8
	movwf	wpua	; ra3 bels felhzval
	movlw	1
	movwf	ansela	; ra0 analg bemenet
	bsf	adcon,adon
	movlw	250
	movwf	pr2
	movlw	48h
	movwf	t2con	; 100 Hz, mg nem fut
	clrf	tmr2
	clrf	flags
	movlw	20
	movwf	div_20
	clrf	phc
	bsf	iocan,3
	bsf	pie1,tmr2ie
	bsf	intcon,peie
main	; fhurok
	movf	phc,w
	sz
	goto	main	; csak phc=0 engedi aludni
	bcf	intcon,gie
gwt
	jnb	gomb,gwt
	bcf	out
	bcf	sound
	clrf	iocaf
	bsf	intcon,iocie
	sleep
	nop
	bcf	intcon,iocie
	clrf	pir1
	clrf	tmr2
	bsf	adgo
adwt0	snb	adgo
	goto	adwt0
	cjbl	adres,8,stopit
	movlw	20
	movwf	div_20
	movlw	10
	movwf	div_10
	clrf	cnt_2
	incf	phc,f
	bsf	ton
	bsf	intcon,gie
	bsf	out
	goto	main
stopit
	clrf	phc
	goto	main
	
load4
	movwf	aux1
	movlw	msg
	movwf	fsr
	movlw	4
	movwf	mcnt
getlp
	call	get1
	movwf	indf
	incf	fsr,f
	incf	aux1,f
	decfsz	mcnt,f
	goto	getlp
	return
get1	movf	aux1,w
	movwf	pcl			
; mindig ngy lesz eltltve	
s_rdy	dt	0bah,0,0,0		; 20
s_sos	dt	0a8h, 0eeh, 0e2h, 0a0h	; 32
s_rip	dt	0bah, 28h, 0bbh, 0a0h	; 32
	end