; rohde.asm: a Rohde hullm kzeltse 8 bites kimenettel

	list		p=16f1704      
	list		r=dec
	#include	<p16f1704.inc> 

	__CONFIG _CONFIG1, _FOSC_INTOSC & _WDTE_OFF & _PWRTE_ON & _MCLRE_OFF & _CP_OFF  & _BOREN_ON & _CLKOUTEN_OFF & _IESO_OFF  & _FCMEN_OFF
	__CONFIG _CONFIG2, _WRT_OFF & _PLLEN_ON & _STVREN_OFF & _BORV_LO & _LVP_OFF
	
; Vltozk
	cblock	0x20
	ENDC
	cblock	0x70	; 
	ptr
	savep
	endc

; makro
movl	macro dest,lit
	movlw	lit
	movwf	dest
	endm

; program
	org	0
	nop
	pagesel	start
	goto	start
; valjban nincs is megszakts, csak a helye
	org	4
	retfie

; fprogram, az alkalomhoz ill inicializlssal
start
	banksel	lata
	clrf	lata
	clrf	latc
	banksel	osccon
	movl	osccon,70h	; 8 x 4 MHz bels
	banksel	trisa
	movl	trisa,3ch
	movl	trisc,3eh
	bcf	option_reg,7
	bcf	option_reg,tmr0cs
	banksel	odcona
	movlw	2
	movwf	odcona
	banksel	ansela
	movlw	1
	movwf	ansela
	clrf	anselc
	banksel	wpua
	movl	wpua,38h	
	movl	wpuc,3ah
	banksel	dac1con0
	clrf	dac1con1
	movl	dac1con0,91h	;kimenet ra2, neg. ref. ra0, eng. (a0 volt)
	; ezzel az opa kimenet is rvidl 0,6 V-ot, de alul.
	banksel	opa1con
	movl	opa1con,0d2h
	banksel	t2con
	clrf	tmr2
	movlw	249
	movwf	pr2
	movlw	6
	movwf	t2con
	#include <clc1.inc>
	banksel	ra1pps
	movlw	4
	movwf	ra1pps
	movlw	0x84
	movwf	fsr0h
	clrf	fsr0l
ro_lp
	moviw	fsr0++		; 2
	banksel	dac1con1 ;3
	movwf	dac1con1 ;4
	movf	fsr0h,w	;5
	banksel	lata	;6
	movwf	latc	;7
	bcf	fsr0h,1	;8
	goto	ro_lp	;10

	org	400h
	#include <hullam.inc>
	end	
	 