; tda.asm: a vdrlnc oszcilltor programja
; fosc=16MHz, tmr2it=1 kHz.

	list p=12f1501
	list r=dec
	#include <p12f1501.inc>

	__CONFIG _CONFIG1, _FOSC_INTOSC & _WDTE_OFF & _PWRTE_ON & _MCLRE_OFF & _CP_OFF & _BOREN_OFF & _CLKOUTEN_OFF 
        __CONFIG _CONFIG2, _WRT_OFF &  _STVREN_OFF & _BORV_HI & _LVP_OFF
 
	cblock 20h
	endc
; knyelmi okbl a frekvencia szmtshoz szksges vltozk
; mindenhonnan lthatk:
	cblock 70h
	adacch
	adaccl
	adcnt
	flags
	mul2
	mul1
	mul0
	res2
	res1
	res0
	time
	aux
	endc

#define newad	flags,0
 
clc	macro
	bcf	status,c
	endm
stc	macro
	bsf	status,c
	endm
snc	macro
	btfsc	status,c
	endm
sc	macro
	btfss	status,c
	endm
snz	macro
	btfsc	status,z
	endm
sz	macro
	btfss	status,z
	endm
	
rl3	macro
	clc
	rlf	mul0,f
	rlf	mul1,f
	rlf	mul2,f
	endm
add3	macro
	movf	mul0,w
	addwf	res0,f
	movf	mul1,w
	addwfc	res1,f
	movf	mul2,w
	addwfc	res2,f
	endm

	org	0
	goto	start
	org	4	; ad it
	banksel	0
	bcf	pir1,adif
	banksel	t1con
	movlw	0c1h
	movwf	tmr1h
	banksel	adresh
	movf	adresl,w
	addwf	adaccl,f
	movf	adresh,w
	addwfc	adacch,f
	decfsz	adcnt,f
	retfie
	movf	adaccl,w
	movwf	mul0
	movf	adacch,w
	movwf	mul1
	bsf	newad
	clrf	adaccl
	clrf	adacch
	movlw	8
	movwf	adcnt
	movlw	184	;23x8
	subwf	mul0,f
	movlw	0
	subwfb	mul1,f
	btfss	mul1,7
	retfie
	movlw	8
	movwf	mul0
	clrf	mul1
	retfie

start	;fprogram
	banksel	0
	movlw	30h	;az inverz program magasban bred
	movwf	porta	;minden kimenet nullrl induljon (?)
	banksel	osccon
	movlw	7ah
	movwf	osccon	; 16 MHz
	movlw	08h
	movwf	option_reg
	movlw	9
	movwf	trisa	; csak 1 bemenet
	bsf	pie1,adie
	movlw	16
	movwf	wdtcon
	banksel	ansela
	movlw	1
	movwf	ansela	; ra0 analg bemenet
	banksel	wpua
	movlw	8
	movwf	wpua
; trendezzk a kimeneteket
	banksel	apfcon
	movlw	0c0h
	movwf	apfcon
	#include <felez.inc>
; belltjuk timer2 kezd peridusidejt a leghosszabbra:
	banksel	pr2
	movlw	199
	movwf	pr2
	movlw	4
	movwf	t2con	; 
; aztn timer1 lesz kb. 1 ms, az adc kzelt peridusideje:
	movlw	0c1h
	movwf	tmr1h
	movlw	80h
	movwf	tmr1l
	movlw	41h
	movwf	t1con
	banksel	0
	movf	porta,w
	movwf	aux
	banksel	adcon0
	movlw	0d0h
	movwf	adcon1
	movlw	40h
	movwf	adcon2	; timer1 fogja indtani az ad konverzit
	bsf	adcon0,0
; elksztjk az NCO-t:
	banksel	nco1con
	clrf	nco1accl
	clrf	nco1acch
	clrf	nco1accu
	movlw	1
	movwf	nco1clk	; hfintosc, 16 MHz
	movlw	080h
	movwf	nco1con	; engedlyezve, de a lba nem
; s a CWG-t:
	banksel	cwg1con0
	movlw	80h
	movwf	cwg1con2	;shutdown
	movlw	5
	movwf	cwg1dbr
	movwf	cwg1dbf
	movlw	0f6h		; shdn llapot=1, forrs=nco1
	btfss	aux,3		; de ha van jumper,
	movlw	0f7h		; akkor a clc1 
	movwf	cwg1con1
	movlw	0f8h		;invertlt kimenetek
	movwf	cwg1con0
	banksel	0
	clrf	adaccl
	clrf	adacch
	movlw	8
	movwf	adcnt
; engedlyezzk a megszaktst
	clrf	pir1
	bsf	intcon,peie
	bsf	intcon,gie
; s mr mehet is a szorzs
main	;  fhurok
	btfss	newad
	goto	main
	clrf	mul2
	clrf	res0
	clrf	res1
	clrf	res2
	add3
	rl3
	rl3
	rl3
	movf	mul1,w
	movwf	time	; 3 baltols utn ments (max. 250)
	rl3
	add3
	rl3
	add3
	rl3
	rl3
	rl3
	rl3
	rl3
	rl3
	add3
	banksel nco1con
	movf	res1,w
	movwf	nco1incl
	movf	res2,w
	movwf	nco1inch
	movlw	51
	subwf	time,f
	snz
	incf	time,f
	movlw	1
	sc
	movwf	time
	movf	time,w
	banksel	pr2
	movwf	pr2
	bcf	newad
	banksel	cwg1con0
	btfsc	cwg1con2,7
	bcf	cwg1con2,7	; shutdown megsznik
	goto	main
	
	end